	.include "8535def.inc"
	
	.def tmp = R16
	.def tmp2 = R17
	.def anod = R18

	.equ indbuf = 0x60
	
	.equ T1_value = 65536-12500;	  TCNT1      0,1 


	rjmp init;		  
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	rjmp T1_int;		       T1
	reti
	reti
	reti
	reti
	reti
	rjmp ADC_int;		      
	reti
	reti

init:
	ldi tmp,high(RAMEND)
	out SPH,tmp
	ldi tmp,low(RAMEND)
	out SPL,tmp;		 
	ldi anod,0xF0
	out PORTA,anod
	out DDRA,anod;		    PA7:PA4  
	ser tmp
	out DDRC,tmp;		     
	clr tmp
	ldi XH,high(indbuf)
	ldi XL,low(indbuf)
ind_clear:
	st X+,tmp
	cpi XL,low(indbuf+3)
	brne ind_clear;		      
	ldi tmp,0b00000011
	out TCCR0,tmp;		  T0: F=CK/64 -   2,048 
	ldi tmp,0b00000011
	out TCCR1B,tmp;		  T1: F=CK/64
	ldi tmp,low(T1_value)
	ldi tmp2,high(T1_value)
	out TCNT1H,tmp2
	out TCNT1L,tmp
	ldi tmp,0b00000100
	out TIMSK,tmp;		    T1
	ldi tmp,0b00000101
	out TIFR,tmp;		        T0,T1
	ldi tmp,0x03
	out ADMUX,tmp;		   
	ldi tmp,0b11011110
	out ADCSR,tmp;		 : F=CK/64,    ,  
	sei;			  

;	 
ind:
	lsl anod
	ori anod,0x10;		       "1"    
	mov tmp,anod
	andi tmp,0x70
	cpi tmp,0x70
	brne next_ind;		  -      "0",      
	ldi anod,0xE0;		          
	ldi XH,high(indbuf)
	ldi XL,low(indbuf);		       
next_ind:
	ldi tmp,0xF0
	out PORTA,tmp;		  PORTA     
	ld tmp,X+;		         
	ldi ZH,high(seg7<<1)
	ldi ZL,low(seg7<<1)
	clr tmp2
	add ZL,tmp
	adc ZH,tmp2;		      ,   
	lpm
	out PORTC,R0;		          PORTC		
	out PORTA,anod;		  PORTA      -   
T0_wait:	in tmp,TIFR
	sbrs tmp,0
	rjmp T0_wait;		     T0  ,   T0_wait
	ldi tmp,0x06
	out TCNT0,tmp;		   TCNT0  0x06 -   T0  2
	ldi tmp,0b00000001
	out TIFR,tmp;		     T0
	rjmp ind;		   ind


;	    
ADC_int:
	push tmp2
	push tmp
	in tmp,SREG
	push tmp;		     
	in tmp,ADCL
	in tmp2,ADCH
	andi tmp2,0x03
	sts indbuf+2,tmp2;		   indbuf+2   ADCH
	mov tmp2,tmp
	swap tmp2
	andi tmp2,0x0F
	andi tmp,0x0F
	sts indbuf+1,tmp2;		   indbuf+1     ADCL
	sts indbuf,tmp;		   indbuf     ADCL
	rjmp ret0

;	     T1
T1_int:	push tmp2
	push tmp
	in tmp,SREG
	push tmp;		     
	ldi tmp,low(T1_value)
	ldi tmp2,high(T1_value)
	out TCNT1H,tmp2
	out TCNT1L,tmp;		  TCNT1      0,1 
	sbi ADCSR,6;		  
ret0:	pop tmp
	out SREG,tmp
	pop tmp
	pop tmp2;		     
	reti;		     

;	    flash
seg7:	.db 0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F,0x77,0x7C,0x39,0x5E,0x79,0x71
